<?php

class AddressFileModel {
  public $name;
  public $description;
  public $filename;
  public $orig_filename;
  public $subfolder;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;
  

  public static function create(Array $data) {
    $model = new AddressFile();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model ->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("AddressFile", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new AddressFile($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("AddressFile", "*", "1=1 ORDER BY name, filename");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new AddressFile($data);
      }
    }
    return $items;
    
  }
  
  public static function getFirst() {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("AddressFile", "*", "$where ORDER BY name, filename");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new AddressFile($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    //$res = $db->select("AddressFile", "*", "$where ORDER BY name, filename");
    
    $sql = "SELECT AddressFile.* FROM AddressFile
            LEFT JOIN File ON (Address.file_id = File.id)
            $where
            ORDER BY address_id, name";
    
    $res = $db->query($sql);
    
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new AddressFile($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";

    
    if(array_key_exists("file_id", $filter)) {
      $file_id = $filter['file_id'];
      if(is_numeric($file_id)) {
        $where .= " AND file_id=$file_id";
      }
    }
    
    if(array_key_exists("address_id", $filter)) {
      $address_id = $filter['address_id'];
      if(is_numeric($address_id)) {
        $where .= " AND address_id=$address_id";
      }
    }
    
    //var_dump($filter);exit;
    if(array_key_exists("name", $filter)) {
      $name = FronkDB::singleton()->escape($filter['name']);
      if($name) {
        $where .= " AND name='$name'";
      }
    }
    
    if(array_key_exists("filename", $filter)) {
      $filename = FronkDB::singleton()->escape($filter['filename']);
      if($filename) {
        $where .= " AND File.filename='$filename'";
      }
    }
    
    if(array_key_exists("subfolder", $filter)) {
      $subfolder = FronkDB::singleton()->escape($filter['subfolder']);
      if($subfolder) {
        $where .= " AND File.subfolder='$subfolder'";
      }
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}